'Mitte_Parallele.vbs  zeichnet linie mitten zwischen 2 parallele linien  mike k 27.01.2012


Sub Main

  Dim tcApp      ' Referenz auf TCAD
  Dim TCSel      ' die gegenwrtige auswahl. Wenn nichts ausgewhlt ist, wird das skript beendet
  Dim TCGrf      ' Variable um sich durch jede selektierte Grafik zu bewegen
  Dim TCVertices ' Liste der Scheitelpunkte jeder Grafik
  Dim TCVert     ' Einzelner Scheitelpunkt, endpunkte der linie auszulesen
  
Dim x0
Dim y0
 
Dim x1
Dim y1

Dim x2
Dim y2

Dim x3
Dim y3

Dim xm1
Dim ym1
Dim xm2
Dim ym2

Dim xL

  On Error Resume Next
  ' zugriff auf turbocad
  Set TCApp = GetObject("", "TurboCAD.Application")
  If Err.Number <> 0 Then
    MsgBox "Kein Zugriff auf TurboCAD. Error " & Hex(Err.Number) & ": " & Err.Description
    Err.Clear
    Exit Sub
  End If
  
  ' get the active drawing
  Set TCDraw = TCApp.ActiveDrawing
  If Err.Number <> 0 Then
    MsgBox "Keine offenen Zeichnung. Nichts zu tun."
    Err.Clear
    Exit Sub
  End If
  
  ' get the current selection. If empty, complain and exit.
  Set TCSel = TCDraw.Selection
  If TCSel.Count < 1 Then
    MsgBox "Keine Linien ausgewhlt. Nichts zu tun."
    Exit Sub
  End If


    Set TCGrf = TCSel.Item(0)  
    Set TCVertices = TCGrf.Vertices
    TCVertices.UseWorldCS = True ' Damit bekommen wir die Absoluten Koordinaten, anstelle der internen koordinaten der Grafik
    
    Set TCVert = TCVertices.Item(0)
    x0=TCVert.x
    y0=TCVert.y

    Set TCVert = TCVertices.Item(1)
    x1=TCVert.x
    y1=TCVert.y


    Set TCGrf = TCSel.Item(1)  
    Set TCVertices = TCGrf.Vertices
    TCVertices.UseWorldCS = True ' siehe oben
    
    Set TCVert = TCVertices.Item(0)
    x2=TCVert.x
    y2=TCVert.y

    Set TCVert = TCVertices.Item(1)
    x3=TCVert.x
    y3=TCVert.y


    xm1=(x0+x2)/2
    xm2=(x1+x3)/2 
    ym1=(y0+y2)/2
    ym2=(y1+y3)/2


set xl = TcDraw.Graphics.AddLineSingle(xm1,ym1,0,xm2,ym2,0)

  TCApp = Nothing 
  xl = Nothing
  TCVert = Nothing
  TCVertices = Nothing
  TCGrf = Nothing
  TCSel = Nothing
End Sub  

Main
